<?php
/**
 * iF.SVNAdmin
 * Copyright (c) 2010 by Manuel Freiholz
 * http://www.insanefactory.com/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; version 2
 * of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.
 */
if( !defined('ACTION_HANDLING') ) {
  die("HaHa!");
}

// Check module.
$appEngine->forwardInvalidModule( !$appEngine->isRepositoryEditActive() );

$selrepos = get_request_var( "selected_repos" );

if( $selrepos == NULL )
{
  $appTemplate->addDefine("WARNING");
  $appTemplate->addReplacement("WARNINGMSG",$appTR->tr("You have to select at least one repository."));
}
else
{
  // Iterate all selected items.
  $failed_items = array();
  $c = count( $selrepos );
  for( $i = 0; $i < $c; $i++ )
  {
    $oR = new \svnadmin\core\entities\Repository();
    $oR->name = $selrepos[$i];

    $b = $appEngine->getRepositoryEditProvider()->delete( $oR );
    if( !$b )
    {
      array_push( $failed_items, $oR->name );
    }
  }

  if( empty( $failed_items ) )
  {
    $appTemplate->addDefine("INFO");
    $appTemplate->addReplacement("INFOMSG",$appTR->tr("Done"));
  }
  else
  {
    $appTemplate->addDefine("ERROR");
    $appTemplate->addReplacement("ERRORMSG",$appTR->tr("The following repository(s) could not been deleted:")." " . join(",",$failed_items));
  }
}
?>